/*
 * CSI2131 Winter 2005
 *
 * Assignment#2 Solution Part-1 : DataFile Creation !!
 *
 * Shantanu Das 
 *
 * This program takes the file contianing course records and creates 
 * the datafile using compact notation. Both filenames are passed from command line.
 * 
 */


#include <iostream>
#include <fstream>
#include <string>
using namespace std;

const int START = 1997;   //Starting year.

// main method ... uses command line arguments

int main(int argc,char* argv[])
{
   
  fstream input;                  // input stream
  fstream output;				  // output stream
  
  // check for the correct number of arguments.
  if(argc!=3){
	  cerr << "USAGE: " << argv[0] << " <Inputfile> <Outputfile>" << endl;
	  return 1;
  }

  // open the file for input
  input.open(argv[1], ios::in);

  // Check to make sure that we could open the file properly!
  if (input.fail()) {
    cerr << "Could not open file ";
    cerr << argv[1];
    cerr << ".\n";
    return 1;
  }

  // open the output file in binary mode
  output.open(argv[2], ios::out|ios::binary|ios::trunc);

  // Check to make sure that we could open the file properly!
  if (output.fail()) {
    cerr << "Could not create file ";
    cerr << argv[2];
    cerr << ".\n";
    return 1;
  }

  string str,cname,pname,clink,plink;
  unsigned char b1;
  unsigned short int b23;
  char sec = ' ';
  int year,term,code1,code2;

  int count =0;
   
  while(input.good() && input.peek()!=EOF)
  {
	  getline(input,str);
	  year=atoi(str.c_str());
	  if(year < START || year > (START+84))
		  cout<< "bad year " << str << endl;
		
	  getline(input,str);
	  if(str.compare("Fall")==0)  term=0;
	  else if(str.compare("Winter")==0)  term=1;
	  else if(str.compare("Summer")==0)  term=2;
	  else cout<< "bad term: " << str << endl;

	  getline(input,str);
	  string front=str.substr(0,3);
	  if(front.compare("CEG")==0)  code1=0;
	  else if(front.compare("CSI")==0)  code1=1;
	  else if(front.compare("ELG")==0)  code1=2;
	  else if(front.compare("GNG")==0)  code1=3;
	  else if(front.compare("SEG")==0)  code1=4;
	  else cout<< "bad code: " << str;
	  code2 = atoi(str.substr(3,4).c_str());


	  getline(input,str);
	  if(str.length()<=0) sec=' ';
	  else sec = str.at(0);
	  getline(input,str);
	  cname=str;
	  getline(input,str);
	  pname=str;
	  getline(input,str);
	  clink=str;
	  getline(input,str);
	  plink=str;
	  getline(input,str);		//get the *'s
	  
b1=(year-START)*3+term;
b23=(code2*5)+code1;

output.write((char*)&b1,1);
output.write((char*)&b23,2);
output.write(&sec,1);
output.write(cname.c_str(),cname.length());
output.put('|');
output.write(pname.c_str(),pname.length());
output.put('|');
output.write(clink.c_str(),clink.length());
output.put('|');
output.write(plink.c_str(),plink.length());
output.put('|');				// THis is reqd. bcoz no length-indicator.

count++;
  }

  // Program completed successfully! */
  cout<< "Datafile created in "<< argv[2] << " with " << count <<" records." <<endl;
  return 0;
}





